using bdAntifraude.db;
using bdAntifraude.dbcontext;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using Serialize.Linq.Serializers;
using System.Linq.Expressions;

namespace SwaggerAntifraude.Controllers
{
    [ApiController]
    [Route("api/[controller]")]
    public class DOCENCIAController : GenericoController<DOCENCIA, int>
    {
        public DOCENCIAController()
            : base()
        {
        }


        [Authorize(Policy = "LecturaPolicy")]
        [HttpGet("{id}")]
        public override IActionResult GetById(int id)
        {
            try
            {
                using (var context = tsGestionAntifraude.NuevoContexto(SoloLectura: true, UseLazyLoadingProxies: false))
                {
                    //var dbSet = context.Set<PUESTOS>();
                    var entity = context.DOCENCIA
                        .Include(x => x.IDPERSONANavigation)
                        .Include(x => x.IDTIPODOCENCIANavigation)
                    .AsNoTracking()
                    .FirstOrDefault(v => v.IDDOCENCIA == id);

                    if (entity == null)
                        return NotFound();

                    return Ok(entity);
                }
            }
            catch (Exception ex)
            {
                return StatusCode(500, $"Error interno del servidor: {ex.Message}");
            }
        }
        [Authorize(Policy = "LecturaPolicy")]
        [HttpGet("docenciaspersona/{idPersona}")]
        public async Task<IActionResult> DocenciaPersona(int idPersona)
        {
            try
            {
                using (var context = tsGestionAntifraude.NuevoContexto(SoloLectura: true, UseLazyLoadingProxies: false))
                {
                    // Consulta con Includes necesarios
                    var entity = await context.DOCENCIA
                    .Include(p => p.IDPERSONANavigation)
                    .Include(p => p.IDTIPODOCENCIANavigation)
                    .AsNoTracking()
                    .Where(p => p.IDPERSONA == idPersona).ToListAsync();

                    // Verifica si la entidad no se encontró
                    if (entity == null)
                        return NotFound($"El puesto con ID {idPersona} no fue encontrado.");

                    // Devuelve la entidad con las relaciones cargadas
                    return Ok(entity);
                }
            }
            catch (Exception ex)
            {
                return StatusCode(500, $"Error interno del servidor: {ex.Message}");
            }
        }


        [Authorize(Policy = "LecturaPolicy")]
        [HttpPost("filtrar")] // Cambié a POST ya que estás usando [FromBody]
        public override async Task<IActionResult> Filtrar([FromBody] ExpressionWrapper request)
        {
            try
            {
                using (var context = tsGestionAntifraude.NuevoContexto(SoloLectura: true, UseLazyLoadingProxies: false))
                {
                    // Crear el deserializador
                    var serializer = new ExpressionSerializer(new Serialize.Linq.Serializers.JsonSerializer());

                    // Deserializar la expresión
                    var deserializedExpression = serializer.DeserializeText(request.Expression) as Expression<Func<DOCENCIA, bool>>;
                    if (deserializedExpression == null)
                    {
                        return BadRequest("La expresión deserializada es nula o incorrecta.");
                    }
                    var entities = await context.DOCENCIA.Where(deserializedExpression)
                                                              .Include(x => x.IDPERSONANavigation)
                        .Include(x => x.IDTIPODOCENCIANavigation)
                                           .AsNoTracking()
                                           .ToListAsync();

                    // Verificar si el resultado es vacío
                    if (entities.Count == 0)
                    {
                        Console.WriteLine("La consulta no devolvió resultados.");
                    }

                    return Ok(entities);
                }
            }
            catch (Exception ex)
            {
                return StatusCode(500, $"Error interno del servidor: {ex.Message}");
            }
        }
    }
   
}
